// complex_numbers.cpp
//
#ifdef _WIN32
	#include <tchar.h>
	#include <conio.h>
#elif (defined __linux__) || (defined _AIX) || (defined __APPLE__)
	typedef char _TCHAR;
	#define _tmain main
#endif

#include <stdio.h>
#include <iostream>
#include <iomanip>
using namespace std;

void my_getch();
//---------------------------------------------------------------------------
// Uzivatelsky definovana trieda
class TCisloKomplexne {
	float Re, Im; // defaultna vizibilita triedy class je private
public:
	TCisloKomplexne();
	void setCisloKomplexne(const float&, const float&); // const;
	TCisloKomplexne SucetKomplCisel(const TCisloKomplexne);
	// nasledujuca deklaracia sa berie ako CLENSKA funkcia
	//	const TCisloKomplexne operator+(const TCisloKomplexne&) const;
	// nasledujuca deklaracia sa berie ako NECLENSKA funkcia
	friend const TCisloKomplexne operator+(const TCisloKomplexne&,
		const TCisloKomplexne&);
	// pretazenie vstupneho alebo vystupneho prudu je vzdy NECLENSKA funkcia
	friend ostream& operator<<(ostream&, const TCisloKomplexne&);
	// friend spristupni private a protected polozky triedy neclenskej funkcii
};
//---------------------------------------------------------------------------
TCisloKomplexne::TCisloKomplexne()
{
	Re = 0;
	Im = 0;
}
//---------------------------------------------------------------------------
void TCisloKomplexne::setCisloKomplexne(const float& _re, const float& _im) // const
{
	Re = _re;
	Im = _im;
}
//---------------------------------------------------------------------------
TCisloKomplexne TCisloKomplexne::SucetKomplCisel(const TCisloKomplexne right)
{
	TCisloKomplexne z;

	z.Re = Re + right.Re;
	z.Im = Im + right.Im;

	return z;
}
//---------------------------------------------------------------------------
/* // Pretazenie operatora scitania + ako clenskej funkcie -- NEODPORUCA SA --
const TCisloKomplexne TCisloKomplexne::operator+(const TCisloKomplexne& right) const
{
TCisloKomplexne z;

z.Re = Re + right.Re;
z.Im = Im + right.Im;

// Nasledujuce 2 riadky robia to same ako predchadzajuce 2 riadky
//	z.Re = (*this).Re + right.Re;
//	z.Im = this->Im + right.Im;

return z;
} */
//---------------------------------------------------------------------------
// Pretazenie operatora scitania + podla syntaxu v tabulke
// Telo pretazenia je identicke s telom predchadzajucej funkcie, iba hlavicka je ina
const TCisloKomplexne operator+(const TCisloKomplexne& left,
	const TCisloKomplexne& right)
{
	TCisloKomplexne z;

	z.Re = left.Re + right.Re;
	z.Im = left.Im + right.Im;

	return z;
}
//---------------------------------------------------------------------------
// Pretazenie operatora vystupneho prudu <<
ostream& operator<<(ostream& os, const TCisloKomplexne& com)
{
	os.setf(ios::fixed, ios::floatfield);  // nastavenie formatu
	os.precision(4);                      // nastavenie poctu desatinnych miest
	os << setw(6) << com.Re;              // nastavenie sirky vypisu
	if (com.Im != 0) {
		os.setf(ios::showpos);              // setf, precision, unsetf su operatory
		os << setw(6) << com.Im << 'i';     // setw je manipulator
		os.unsetf(ios::showpos);            // setw potrebuje #include <iomanip.h>
	}
	return os;
}
//---------------------------------------------------------------------------
void my_getch()
{
#ifdef _WIN32
	_getch();
#else
	cout << endl;
#endif
}
//---------------------------------------------------------------------------
int _tmain(int argc, _TCHAR* argv[])
{
	// TCisloKomplexne je trieda, t.j., typ premennej
	// kompl_cislo[0], kompl_cislo[1], kompl_cislo[2],vysledok1 a vysledok2 su objekty
	// alebo instancie triedy TCisloKomplexne, t.j. premenne typu TCisloKomplexne
	unsigned i;
	float re, im;
	TCisloKomplexne kompl_cislo[3], vysledok1, vysledok2;

	cout << "\nKonstruktor nastavil pociatocne hodnoty vsetkych komplexnych cisel:";
	for (i = 0; i < 3; i++)
		cout << "\nkompl_cislo[" << i << "] = " << kompl_cislo[i];
	cout << "\nvysledok1 = " << vysledok1;
	cout << "\nvysledok2 = " << vysledok2;

	cout << "\n\nZ klavesnice nacitajte 2 komplexne cisla a na obrazovku"
		<< " vypiste ich sucet.\n\n";

	cout << "Zadajte dve komplexne cisla ich realnymi (Re) a imaginarnymi"
		<< " (Im)zlozkami:\n";
	for (i = 0; i < 2; i++) {
		cout << "kompl_cislo[" << i << "]: Re = ";
		cin >> re;
		cout << "kompl_cislo[" << i << "]: Im = ";
		cin >> im;
		kompl_cislo[i].setCisloKomplexne(re, im);
		cout << endl;
	}

	vysledok1 = kompl_cislo[0].SucetKomplCisel(kompl_cislo[1]);
	cout << "vysledok1 = kompl_cislo[0].SucetKomplCisel(kompl_cislo[1]); dava:\n";
	cout << kompl_cislo[0] << " + " << kompl_cislo[1] << " = " << vysledok1;

	vysledok2 = kompl_cislo[0] + kompl_cislo[1];
	cout << "\n\nvysledok2 = kompl_cislo[0] + kompl_cislo[1]; dava:\n";
	cout << kompl_cislo[0] << " + " << kompl_cislo[1] << " = " << vysledok2;

	cout << "\n\nMedzi objekty mozeme davat prikaz priradenia =. Medzi polami to nejde!!!\n\n";
	kompl_cislo[2] = kompl_cislo[0];
	cout << "Prikaz kompl_cislo[2] = kompl_cislo[0] dava:\n";
	cout << "kompl_cislo[2] = " << kompl_cislo[2] << endl;

	my_getch();
	return 0;
}
//---------------------------------------------------------------------------